try
{
	
System.Gadget.settingsUI = "settings.html";

var httpReq = false;

function Feeds()
{
	try
	{
		if(Feeds.instance) throw("only one instance of Feeds is allowed");

		var _self = this;

		_self.feeds			= new Array();
		_self.keyWords		= new Array();
		_self.ticker		= false;
		_self.tickspeed		= 50;

		_self.AddFeed = function(url,name,interval)
		{
			try
			{
				_self.feeds.push(new Feed(url,name,interval));
			}
			catch (e)
			{
				document.getElementById("root").innerHTML = "gfdgdfg"+e.message;
			}
		}

		_self.ClearFeeds = function()
		{
			_self.feeds = new Array();
		}

		_self.keyWordsMatch = function(item)
		{
			var found = false;

			try
			{
				for(var i=0;i<_self.keyWords.length;i++)
				{
					if(item.selectSingleNode("title").text.toLowerCase().indexOf(_self.keyWords[i])>=0) found = true;
					if(item.selectSingleNode("description").text.toLowerCase().indexOf(_self.keyWords[i])>=0) found = true;
				}
			}
			catch (e)
			{
			}

			return found;
		}

		_self.Redraw = function()
		{
			var inner = document.getElementById("innerRoot");

			if(!inner)
			{
				inner = document.createElement("div");
				inner.id = "innerRoot";
				inner.style.position = "absolute";
				inner.style.left = 0;
				inner.style.top = 0;
				inner.style.width = "120px";
				document.getElementById("root").appendChild(inner);
			}

			

			var itemCount = 0;

			for(var i=0;i<_self.feeds.length;i++)
			{		
				for(var j=0;j<_self.feeds[i].items.length;j++)
				{
					itemCount++;

					
					try
					{
						//document.getElementById("debug").innerHTML += "("+i+","+j+"_"+_self.feeds[i].items[j].replace(/[^a-z]/ig,"-")+")<br/>";
						var existing = document.getElementById("("+i+","+j+"_"+_self.feeds[i].items[j].replace(/[^a-z]/ig,"-")+")");
						if(existing != null) continue;
					}
					catch (e)
					{
						//document.getElementById("debug").innerHTML += e.message;
					}

					//document.getElementById("debug").innerHTML += "-append<br/>";
					

					

					var div				= document.createElement("div");
					div.id				= "("+i+","+j+"_"+_self.feeds[i].items[j].replace(/[^a-z]/ig,"-")+")";
					div.className		= "rssItem newRssItem";


					if(System.Gadget.Settings.readString("item-line-separator") == "true")
					div.style.borderTop = "1px solid "+System.Gadget.Settings.readString("scroll-list-font-color");

					if(_self.keyWordsMatch(_self.feeds[i].news[_self.feeds[i].items[j].replace(/[^a-z]/ig,"-")]))
					div.className		+= " matchSearchRssItem";
					
					var imp				= document.createElement("span");
					imp.innerHTML		= "";
					imp.className		= "newItemMark";
					imp.style.display   = "none";
					imp.id				= new Date().getTime();
					div.appendChild(imp);
					

					var text = document.createElement("div");
					text.className				= "itemTitle";
					text.style.fontFamily		= System.Gadget.Settings.readString("scroll-list-font");
					text.style.fontSize			= System.Gadget.Settings.readString("scroll-list-font-size");
					text.style.color			= System.Gadget.Settings.readString("scroll-list-font-color");
					text.style.fontWeight		= System.Gadget.Settings.readString("scroll-list-font-weight");

					//text.innerHTML = _self.feeds[i].items[j];
					
					if(System.Gadget.Settings.readString("display-title-"+_self.feeds[i].name) == "true")
					{
						var feedname = document.createElement("div");
						feedname.style.padding		= "0px!important";
						feedname.style.margin		= "0px!important";
						//feedname.style.whiteSpace	= "nowrap";
						feedname.className			= "itemFeedName";
						feedname.style.borderBottom = "1px dashed "+System.Gadget.Settings.readString("scroll-list-font-color");

						feedname.innerHTML			= _self.feeds[i].name;

						text.appendChild(feedname);
					}
					

					var bread = document.createElement("div");
					bread.style.padding = "0px!important";
					bread.style.margin = "0px!important";
					bread.innerHTML = _self.feeds[i].items[j];
					text.appendChild(bread);



					div.appendChild(text);

					if(text.innerHTML.length<=0) text.innerHTML = "["+_self.feeds[i].name+"]";

					div.ondblclick = function(e)
					{
							var targ;
							if(!e) e = window.event;
							if (e.target) targ = e.target;
							else if (e.srcElement) targ = e.srcElement;

							while(targ.className.indexOf("rssItem")<0) targ = targ.parentNode;

							var id = targ.id;

							var feedId = id.substr(id.indexOf("(")+1,id.indexOf(",")-1);
							var itemId = id.substr(id.indexOf(",")+1,id.indexOf(")")-id.indexOf(",")-1);
	
							if(!_self.feeds[feedId]) return false;
							if(!_self.feeds[feedId].news[itemId]) return false;

							System.Gadget.Flyout.show = false;

							window.open(_self.feeds[feedId].news[itemId].selectSingleNode("link").text);
					}

					div.onmouseover = function(e)
					{
							var targ;
							if(!e) e = window.event;
							if (e.target) targ = e.target;
							else if (e.srcElement) targ = e.srcElement;

							while(targ.className.indexOf("rssItem")<0) targ = targ.parentNode;

							if(targ.className.indexOf("newRssItem")>=0)
							{
								if(targ.className.indexOf("matchSearchRssItem")>=0)
									targ.className = "rssItem rssItemHover newRssItem matchSearchRssItem";
								else
									targ.className = "rssItem rssItemHover newRssItem";
							}
							else
							{
								if(targ.className.indexOf("matchSearchRssItem")>=0)
									targ.className = "rssItem rssItemHover matchSearchRssItem";
								else
								targ.className = "rssItem rssItemHover";
							}
					}

					div.onmouseout = function(e)
					{
							var targ;
							if(!e) e = window.event;
							if (e.target) targ = e.target;
							else if (e.srcElement) targ = e.srcElement;

							while(targ.className.indexOf("rssItem")<0) targ = targ.parentNode;

							if(targ.className.indexOf("newRssItem")>=0)
							{
								if(targ.className.indexOf("matchSearchRssItem")>=0)
									targ.className = "rssItem newRssItem matchSearchRssItem";
								else
									targ.className = "rssItem newRssItem";
							}
							else
							{
								if(targ.className.indexOf("matchSearchRssItem")>=0)
									targ.className = "rssItem matchSearchRssItem";
								else
									targ.className = "rssItem";
							}
					}

					div.onmousedown = function(e)
					{
						try
						{
							var targ;
							if(!e) e = window.event;
							if (e.target) targ = e.target;
							else if (e.srcElement) targ = e.srcElement;

							while(targ.className.indexOf("rssItem")<0) targ = targ.parentNode;

							if(System.Gadget.Settings.readString("click-to-remove-new-item-flag") == "true")
							{
								var spans = targ.getElementsByTagName("span");
								for(var i=0;i<spans.length;i++)
								{
									if(spans[i].className.indexOf("newItemMark")>=0)
									{
										targ.removeChild(spans[i]);
										targ.className = targ.className.replace("newRssItem","");
										break;
									}
								}
							}

							

							//if(System.Gadget.Flyout.file != "details.html")

							System.Gadget.Flyout.file	= "details.html";
							System.Gadget.Flyout.show	= true;
							_self.detailsId				= targ.id;
						}
						catch (e)
						{
							System.Gadget.Flyout.document.getElementById("title").innerHTML = e.message;
						}
					}
					
					inner.appendChild(div);
				}
			}
		}

		_self.itemExists = function(element)
		{
			try
			{
				var id = element.id;
				var feedId = id.substr(id.indexOf("(")+1,id.indexOf(",")-1);
				var itemId = id.substr(id.indexOf(",")+1,id.indexOf(")")-id.indexOf(",")-1);
				//itemId = itemId.substr(itemId.indexOf("_")+1);

				if(!_self.feeds[feedId]) return false;
				if(!_self.feeds[feedId].news[itemId]) return false;
			}
			catch (e)
			{
				return false;
			}

			return true;
		}


		_self.getItem = function(id)
		{
			var feedId = id.substr(id.indexOf("(")+1,id.indexOf(",")-1);
			var itemId = id.substr(id.indexOf(",")+1,id.indexOf(")")-id.indexOf(",")-1);
			
			var feedId = id.substr(id.indexOf("(")+1,id.indexOf(",")-1);
			var itemId = id.substr(id.indexOf(",")+1,id.indexOf(")")-id.indexOf(",")-1);

			return _self.feeds[feedId].news[itemId];
		}

		_self.setDetails = function(id)
		{
				var feedId = id.substr(id.indexOf("(")+1,id.indexOf(",")-1);
				var itemId = id.substr(id.indexOf(",")+1,id.indexOf(")")-id.indexOf(",")-1);
				
				var feedId = id.substr(id.indexOf("(")+1,id.indexOf(",")-1);
				var itemId = id.substr(id.indexOf(",")+1,id.indexOf(")")-id.indexOf(",")-1);

			try
			{

				System.Gadget.Flyout.document.getElementById("feedTitle").innerHTML = _self.feeds[feedId].name;
				System.Gadget.Flyout.document.getElementById("itemTitle").innerHTML = _self.feeds[feedId].news[itemId].selectSingleNode("title").text;


				System.Gadget.Flyout.document.getElementById("itemContents").innerHTML = _self.feeds[feedId].news[itemId].selectSingleNode("description").text;
			
				System.Gadget.Flyout.document.getElementById("footer").innerHTML = "<br/><a href='"+_self.feeds[feedId].news[itemId].selectSingleNode("link").text+"'>Link</a>";
				
				var d = new Date();
				try
				{
					if(_self.feeds[feedId].news[itemId].selectSingleNode("pubDate")) d.setTime(Date.parse(_self.feeds[feedId].news[itemId].selectSingleNode("pubDate").text));
					if(_self.feeds[feedId].news[itemId].selectSingleNode("date")) d.setTime(Date.parse(_self.feeds[feedId].news[itemId].selectSingleNode("date").text));
				}
				catch (e)
				{
					d = false;
				}

				if(d && d.getFullYear()+"" != "NaN")
				{
					System.Gadget.Flyout.document.getElementById("itemDate").innerHTML = d.getFullYear()+"-"+((d.getMonth()<10)?"0":"")+d.getMonth()+"-"+((d.getDate()<10)?"0":"")+d.getDate()+" "+((d.getHours()<10)?"0":"")+d.getHours()+":"+((d.getMinutes()<10)?"0":"")+d.getMinutes()+":"+((d.getSeconds()<10)?"0":"")+d.getSeconds();
				}
				else
					System.Gadget.Flyout.document.getElementById("itemDate").innerHTML = "";
			}
			catch (e)
			{
				System.Gadget.Flyout.document.body.innerHTML = feedId+"->"+itemId+"<br/>"+e.message;
			}
		}

		_self.scroll = function()
		{

		}

		_self.CleanItems = function()
		{
			var inner = document.getElementById("innerRoot");
			if(inner)
			{
				var dirty = true;

				while(dirty)
				{
					dirty = false;

					for(var i=0;i<inner.childNodes.length;i++)
					{
						if(!_self.itemExists(inner.childNodes[i])) 
						{
							inner.removeChild(inner.childNodes[i]);
							dirty = true;
						}
					}
				}

			}
		}

		_self.cnt = new Date().getTime();
		_self.stp = false;


		_self.scrollFeedItems = function()
		{
				var inner = document.getElementById("innerRoot");

				if(inner)
				{	
					try
					{
							
						var posy = eval(inner.style.top.substr(0,inner.style.top.indexOf("px"))-1);

						if(posy+inner.childNodes[0].offsetTop-1+inner.childNodes[0].offsetHeight<0)
						{
							var child = inner.childNodes[0];


							
							var spans = child.getElementsByTagName("span");
							for(var i=0;i<spans.length;i++)
							{
								if(spans[i].className.indexOf("newItemMark")>=0)
								{
									//System.Gadget.Settings.writeString("new-item-flag-duration"
									//if(new Date().getTime() - eval(spans[i].id) > 300000)
									if(new Date().getTime() - eval(spans[i].id) > (eval(System.Gadget.Settings.readString("new-item-flag-duration")*1000)))
									{
										child.removeChild(spans[i]);
										child.className = child.className.replace("newRssItem","");
										break;
									}
								}
							}

							if(_self.keyWordsMatch(_self.getItem(child.id)))
							child.className		+= " matchSearchRssItem";

							inner.removeChild(child);
							if(_self.itemExists(child)) 
							{
								inner.appendChild(child); 
							}
							else
							{
								/*clear memory*/
								inner.ondblclick	= null;
								inner.onmouseover	= null;
								inner.onmouseout	= null;
								inner.onmousedown	= null;
							}
							posy = 0;
						}

						inner.style.top = posy;

					}
					catch (e )
					{
					}
				}
		}

		_self.turnPageFeedItems = function()
		{

		}

		_self.tick = function()
		{
			try
			{
				if(_self.stp) return;

				if(mouseover) return;

				document.getElementById("root").style.overflowY		= "hidden";
				document.getElementById("search").style.display		= "none";
				document.getElementById("toppanel").style.display	= "none";
				document.getElementById("tool").style.display		= "none";
				document.getElementById("window1").style.display	= "none";
				document.getElementById("window2").style.display	= "none";
				document.getElementById("window3").style.display	= "none";
				document.getElementById("reload").style.display		= "none";
				document.getElementById("love").style.display		= "none";
				document.getElementById("explore").style.display	= "none";

				_self.stp = true;

				var nowDate = new Date();
				var itemCount = 0;

				switch(System.Gadget.Settings.readString("displayType"))
				{
					case "none" : 
					break;
					case "scroll" : 
						_self.scrollFeedItems();
					break;
					case "page" : 
						_self.turnPageFeedItems();
					break;
					default : 
						_self.scrollFeedItems();
					break;
				}

				for(var i=0;i<_self.feeds.length;i++)
				{		
					itemCount += _self.feeds[i].items.length;

					if(nowDate.getTime() - _self.feeds[i].updated > _self.feeds[i].updateInterval)
					{
						_self.feeds[i].Load();
					}
				}

				//document.getElementById("numFeeds").innerHTML = _self.feeds.length;
				//document.getElementById("numItems").innerHTML = itemCount;

				_self.cnt = new Date().getTime();
				_self.stp = false;

			}
			catch (e)
			{
				document.getElementById("root").innerHTML = "_self.tick<br/>"+e.message;
			}
		}

		_self.ReloadFeeds = function()
		{
			try
			{
				var path				= System.Gadget.path + "\\feeds.xml";
				var xmldoc				= new ActiveXObject( "Msxml2.DOMDocument.3.0" );
				xmldoc.async			= false;
				xmldoc.load(path);

				var items				= xmldoc.selectNodes("/data/feeds/feed");

				_self.tickspeed			= 3000/Number(xmldoc.selectSingleNode("/data/tickspeed").text);

				System.Gadget.Settings.writeString("scroll-list-font",xmldoc.selectSingleNode("/data/scroll-list").getAttribute("font"));
				System.Gadget.Settings.writeString("scroll-list-font-size",xmldoc.selectSingleNode("/data/scroll-list").getAttribute("font-size"));
				System.Gadget.Settings.writeString("scroll-list-font-color",xmldoc.selectSingleNode("/data/scroll-list").getAttribute("color"));
				System.Gadget.Settings.writeString("scroll-list-font-weight",xmldoc.selectSingleNode("/data/scroll-list").getAttribute("weight"));


				

				if(System.Gadget.Settings.readString("error") != null && System.Gadget.Settings.readString("error").length>0)
				{
					document.body.innerHTML = System.Gadget.Settings.readString("error");
				}
				System.Gadget.Settings.writeString("error","");
				


				System.Gadget.Settings.writeString("click-to-remove-new-item-flag",xmldoc.selectSingleNode("/data/new-item-flag").getAttribute("click-to-remove"));


				System.Gadget.Settings.writeString("item-line-separator",xmldoc.selectSingleNode("/data/item-line-separator").getAttribute("enabled"));

				


				System.Gadget.Settings.writeString("new-item-flag-duration",xmldoc.selectSingleNode("/data/new-item-flag").getAttribute("duration"));

				if(System.Gadget.Settings.readString("proxy-nosave") == "true")
				{
					System.Gadget.Settings.writeString("proxy-nosave","false");
				}
				else
				{
					System.Gadget.Settings.writeString("proxy",xmldoc.selectSingleNode("/data/proxy").text);
					System.Gadget.Settings.writeString("proxy-username",xmldoc.selectSingleNode("/data/proxy").getAttribute("username"));
					System.Gadget.Settings.writeString("proxy-password",xmldoc.selectSingleNode("/data/proxy").getAttribute("password"));
				}

				if(_self.ticker != false) clearInterval(_self.ticker);

				_self.ticker = setInterval(_self.tick,_self.tickspeed);

				var feedchange = false;

				if(items.length != _self.feeds.length)
				{
					feedchange = true;
				}
				else
				{
					for(var i=0;i<_self.feeds.length;i++)
					{
						if(_self.feeds[i].name != items[i].getAttribute("name"))
						{
							feedchange = true;
						}
						else
						{
							_self.feeds[i].interval = Number(items[i].getAttribute("interval"))*60*1000;
						}
					}
				}

				//if(!feedchange) return;

				_self.ClearFeeds();

				for(var i=0;i<items.length;i++)
				{
					System.Gadget.Settings.writeString("display-title-"+items[i].getAttribute("name"),items[i].getAttribute("display-title"));
					Feeds.instance.AddFeed(items[i].text,items[i].getAttribute("name"),Number(items[i].getAttribute("interval")));
				}
			}
			catch (e)
			{
				document.getElementById("root").innerHTML = "_self.ReloadFeeds<br/>"+e.message;
			}
		}

		function initialize()
		{
			//_self.ticker = setInterval(_self.tick,_self.tickspeed);
		}

		initialize();
	}
	catch (e)
	{
		document.getElementById("root").innerHTML = e.message;
	}
}

Feeds.instance = new Feeds();
Feeds.instance.ReloadFeeds();

System.Gadget.onSettingsClosed = function(e)
{
	if (e.closeAction == e.Action.commit) 
	{
		Feeds.instance.ReloadFeeds();
		Feeds.instance.CleanItems();
	}
}

function Feed(url,name,interval)
{
	try
	{
		
		var _self				= this;
		_self.name				= name;
		_self.image				= url;
		_self.link				= url;
		_self.url				= url;
		_self.description		= url;
		_self.updated			= new Date().getTime();
		_self.items				= new Array();
		_self.news				= new Object();
		_self.httpReq			= false;
		_self.display			= true;
		_self.interval			= eval(interval*60*1000);
		_self.updateInterval	= 5000;//Math.round(Math.rand()*5000);
		_self.gadgetDoc			= new ActiveXObject( "Msxml2.DOMDocument.3.0" );
		
		_self.id				= new Guid().toString();

		_self.loader			= new ActiveXObject( "MsXml2.ServerXmlHttp.6.0" );


		_self.asyncLoadByProxyReadyStateChange = function()
		{
				if(_self.loader.readyState != 4) return;
				if(_self.loader.status != 200) return;

				/*
				var oStream = new ActiveXObject("ADODB.Stream");
				with(oStream)
				{
					Mode = 3;
					Type = 2;
					Open();
					WriteText(_self.loader.responseText);
					SaveToFile(System.Gadget.path+"\\"+_self.id+".xml",2);
					Close();
				}
				*/

				_self.gadgetDoc.async	= false;

				if(!_self.loader.responseXML)
				_self.gadgetDoc.loadXML(_self.loader.responseText);
				else
				_self.gadgetDoc.loadXML(_self.loader.responseXML.xml);
				

				_self.asyncLoadReadyStateChange();
		}


		_self.asyncLoadReadyStateChange = function()
		{

			try
			{
				
				if(_self.gadgetDoc.readyState != 4 || _self.gadgetDoc.parseError.errorCode != 0) 
				{
					if( _self.gadgetDoc.parseError.errorCode != 0)
						throw({message: _self.gadgetDoc.parseError.errorCode});
					else
						return;
				}

				_self.name				= _self.gadgetDoc.selectSingleNode("//channel/title").text;
				_self.link				= _self.gadgetDoc.selectSingleNode("//channel/link").text;
				_self.image				= (_self.gadgetDoc.selectSingleNode("//channel/image/url"))?_self.gadgetDoc.selectSingleNode("//channel/image/url").text:"";
				_self.description		= _self.gadgetDoc.selectSingleNode("//channel/description").text;
				var items				= _self.gadgetDoc.selectNodes("//channel/item");

				if(items.length<=0)
				{
					items = _self.gadgetDoc.selectNodes("//item");
				}

				var updated = false;
	
				for(var i=0;i<items.length;i++)
				{
					if(!_self.news[i+"_"+items[i].selectSingleNode("title").text.replace(/[^a-z]/ig,"-")]) updated = true;
				}

				if(updated)
				{
					/*clear memory*/
					delete _self.news;
					_self.news = new Object();
					delete _self.items;
					_self.items = new Array();

					for(var i=0;i<items.length;i++)
					{
						_self.items.push(items[i].selectSingleNode("title").text);
						_self.news[i+"_"+items[i].selectSingleNode("title").text.replace(/[^a-z]/ig,"-")] = items[i];
					}
				}

				//document.getElementById("debug").innerHTML = _self.items.length;

				_self.updated = new Date().getTime();

				if(updated) 
				{
					activityIcon.instance.ping(true);
					Feeds.instance.Redraw();
				}
				else
				{
					activityIcon.instance.ping();
				}

			}
			catch (e)
			{
				//document.body.innerHTML = "asyncLoadReadyStateChange: "+e.message;

			}
		}

		_self.Load = function()
		{
			try
			{		
					_self.updateInterval	= _self.interval;
					_self.updated			= new Date().getTime();
					
					if(System.Gadget.Settings.readString("proxy").length<=0)
					{
						_self.gadgetDoc.onreadystatechange  = _self.asyncLoadReadyStateChange;
						_self.gadgetDoc.load(_self.url);
					}
					else
					{
						_self.loader.setProxy(2,System.Gadget.Settings.readString("proxy"));
						_self.loader.onreadystatechange  = _self.asyncLoadByProxyReadyStateChange;
						_self.loader.open("GET",_self.url,true);
						if(System.Gadget.Settings.readString("proxy").length>0 && System.Gadget.Settings.readString("proxy-username").length>0)
						_self.loader.setProxyCredentials(System.Gadget.Settings.readString("proxy-username"),System.Gadget.Settings.readString("proxy-password"));
						_self.loader.setRequestHeader("User-Agent","Hermes/1.0.4 (Windows; U; Windows NT 6.0; en-US; rv:1.8.1.11)");
						_self.loader.setRequestHeader('Accept-Language', 'en-us;q=0.7,en;q=0.3');
						_self.loader.setRequestHeader("Accept", "text/xml,application/xml,application/xhtml+xml,text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5");
						_self.loader.setRequestHeader("Accept-Charset", "utf-8;q=0.7,*;q=0.7");
						_self.loader.send();
					}

					activityIcon.instance.ping();
					return;

			}
			catch (e)
			{
				_self.updateInterval	= _self.interval;
				_self.updated			= new Date().getTime();
				//document.body.innerHTML = e.message;
			}
		}

	}
	catch (e)
	{
		//document.getElementById("root").innerHTML = e.message;
	}
}



function activityIcon()
{
	if(activityIcon.instance) throw({message:"activityIcon, only one instance is allowed"});

	var _self = this;

	_self.opacity = 0;
	_self.opacity2 = 0;
	_self.opacity3 = 100;

	_self.size		= 1.0;

	_self.start = false;

	_self.ticka = function()
	{
		try
		{
			if(_self.start && _self.opacity3 != 0) 
			{
				document.getElementById("rssiconlarge").style.filter = "Alpha(Opacity="+_self.opacity3+")";
				if(_self.opacity3>1.0) _self.opacity3 *= 0.7; else _self.opacity3 = 0;
				document.getElementById("rssiconlarge").style.width		= 31*_self.size;
				document.getElementById("rssiconlarge").style.height	= 31*_self.size;
				document.getElementById("rssiconlarge").style.left		= 50-(((31*_self.size)-31)/2);
				document.getElementById("rssiconlarge").style.top		= 50-(((31*_self.size)-31)/2);
				_self.size *= 0.8;
				document.getElementById("root").style.filter = "Alpha(Opacity="+((100-_self.opacity3)*0.75)+")"
			} else if(_self.opacity3 == 0) document.getElementById("rssiconlarge").style.display = "none";

			if(self.opacity == 0 && _self.opacity2 == 0) return;

			document.getElementById("rssicon").style.filter = "Alpha(Opacity="+_self.opacity+")";
			if(_self.opacity>1.0) 
			{
				document.getElementById("rssicon").style.display = "block";
				_self.opacity *= 0.8; 
			}
			else 
			{
				document.getElementById("rssicon").style.display = "none";
				_self.opacity = 0;
			}

			if(_self.opacity2 == 0) return;

			document.getElementById("newrssicon").style.filter = "Alpha(Opacity="+_self.opacity2+")";
			if(_self.opacity2>1.0)
			{
				document.getElementById("newrssicon").style.display = "block";
				_self.opacity2 *= 0.6; 
			}
			else
			{
				document.getElementById("newrssicon").style.display = "none";
				_self.opacity2 = 0;
			}
			
		}
		catch (e)
		{
			e.message = "activityIcon.tick"+e.message;
			throw(e);
		}
		
	}

	_self.ping = function(newitem)
	{
		if(newitem)
		{
			_self.opacity2 = 100;
			_self.start = true;
		}
		else
		{
			_self.opacity = 100;
		}
	}

	function initalize()
	{
		try
		{
			setInterval(_self.ticka,50);
		}
		catch (e)
		{
			e.message = "activityIcon.initalize"+e.message;
			throw(e);
		}
	}

	initalize();
}

activityIcon.instance = new activityIcon();


function Guid()
{
	var _self = this;

	_self.value = "";


	var result, i, j;

	var result = '';

	for(j=0; j<32; j++)
	{
		if( j == 8 || j == 12|| j == 16|| j == 20)
		result = result + '-';

		i = Math.floor(Math.random()*16).toString(16).toUpperCase();

		result = result + i;
	}

	_self.value = result;

	this.toString = function()
	{
		return _self.value;
	}
}




}
catch (e)
{
	document.getElementById("root").innerHTML = "startup: "+e.message;
}