var path = System.Gadget.path + "\\feeds.xml";
var xmldoc				= new ActiveXObject( "Msxml2.DOMDocument.3.0" );
xmldoc.async			= false;

var otherfeeds			= new ActiveXObject( "Msxml2.DOMDocument.3.0" );
otherfeeds.async		= false;

function refreshotherfeeds()
{
	try
	{

		var list = document.getElementById("otherfeedslist");
		list.innerHTML = "loading..";
		var loader	= new ActiveXObject( "MsXml2.ServerXmlHttp.6.0" );
		if(System.Gadget.Settings.readString("proxy").length>0)
		loader.setProxy(2,System.Gadget.Settings.readString("proxy"));
		loader.onreadystatechange  = function()
		{
			if(loader.readyState != 4) return;
			if(loader.status != 200) return;
			if(!loader.responseXML)
			otherfeeds.loadXML(loader.responseText);
			else
			otherfeeds.loadXML(loader.responseXML.xml);

			if( otherfeeds.parseError.errorCode != 0)
				list.innerHTML = otherfeeds.parseError.reason;
			else
				refreshOtherFeedList();
		}
		loader.open("GET","http://www.creamdog.se/hermes/feedlist.php",true);
		if(System.Gadget.Settings.readString("proxy").length>0 && System.Gadget.Settings.readString("proxy-username").length>0)
		loader.setProxyCredentials(System.Gadget.Settings.readString("proxy-username"),System.Gadget.Settings.readString("proxy-password"));
		loader.setRequestHeader("User-Agent","Hermes/1.0.4 (Windows; U; Windows NT 6.0; en-US; rv:1.8.1.11)");
		loader.setRequestHeader('Accept-Language', 'en-us;q=0.7,en;q=0.3');
		loader.setRequestHeader("Accept", "text/xml,application/xml,application/xhtml+xml,text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5");
		loader.setRequestHeader("Accept-Charset", "utf-8;q=0.7,*;q=0.7");
		loader.send();
		return;
		
	}
	catch (e)
	{
		document.getElementById("otherfeedslist").innerHTML = "The service is not availible at the moment.<br/>please try again later.";
	}
}

function sendfeedurl()
{
	try
	{
		var url = escape(document.getElementById("addotherfeedurl").value);

		var doc    = new ActiveXObject( "MsXml2.ServerXmlHttp.6.0" );

		if(System.Gadget.Settings.readString("proxy").length>0)
		doc.setProxy(2,System.Gadget.Settings.readString("proxy"));

		
		doc.setTimeouts(50000, 50000, 50000, 50000);

		doc.onreadystatechange  = function()
		{
			if (doc.readyState==4)
			{
				if(doc.status == 200)
				{
					document.getElementById("addotherfeedurl").value = "";
					refreshotherfeeds();
				}
				else
				{
					refreshotherfeeds();
				}
			} 
		}

		doc.open("GET","http://www.creamdog.se/hermes/addfeed.php?url="+url,false);

		doc.setRequestHeader("User-Agent","Hermes/1.0.4 (Windows; U; Windows NT 6.0; en-US; rv:1.8.1.11)");

		if(System.Gadget.Settings.readString("proxy").length>0 && System.Gadget.Settings.readString("proxy-username").length>0)
		doc.setProxyCredentials(System.Gadget.Settings.readString("proxy-username"),System.Gadget.Settings.readString("proxy-password"));
				
		doc.send(); 
	}
	catch (e)
	{	
		document.getElementById("otherfeedslist").innerHTML = e.message;
	}
}


function refreshOtherFeedList()
{
	var feeds = otherfeeds.selectNodes("//feeds/feed");
	var list = document.getElementById("otherfeedslist");

	var feedCategories	= new Array();
	var feedLanguages	= new Array();


	list.innerHTML = "";

	for(var i=0;i<feeds.length;i++)
	{
		var subscr = xmldoc.selectNodes("/data/feeds/feed");

		var hasit = false;

		for(var x=0;x<subscr.length;x++)
		{
			if(subscr[x].text.toLowerCase() == feeds[i].getAttribute("url").toLowerCase())
			{
				hasit = true;
				break;
			}
		}

		if(hasit) continue;


		hasit = false;
		for(var j=0;j<feedCategories.length;j++) if(feedCategories[j]==feeds[i].getAttribute("category") || feeds[i].getAttribute("category").length<=0) hasit = true;
		if(!hasit) feedCategories.push(feeds[i].getAttribute("category"));
		hasit = false;
		for(var j=0;j<feedLanguages.length;j++) if(feedLanguages[j]==feeds[i].getAttribute("language") || feeds[i].getAttribute("language").length<=0) hasit = true;
		if(!hasit) feedLanguages.push(feeds[i].getAttribute("language"));
		hasit = false;

		var item = document.createElement("div");
		
		item.className = "feeddiv";
		item.id = feeds[i].getAttribute("url");

		var addbutton = document.createElement("a");
		addbutton.innerHTML = "Add";
		addbutton.className = "delete";
		addbutton.id = feeds[i].getAttribute("url");

		addbutton.onclick = function(e)
		{
			try
			{
				var targ;
				if(!e) e = window.event;
				if (e.target) targ = e.target;
				else if (e.srcElement) targ = e.srcElement;

				try
				{
					var doc    = new ActiveXObject( "MsXml2.ServerXmlHttp.6.0" );
					if(System.Gadget.Settings.readString("proxy").length>0)
					doc.setProxy(2,System.Gadget.Settings.readString("proxy"));
					doc.open("GET","http://www.creamdog.se/hermes/pokefeed.php?url="+targ.id,true);
					doc.setRequestHeader("User-Agent","Hermes/1.0.4 (Windows; U; Windows NT 6.0; en-US; rv:1.8.1.11)");
					if(System.Gadget.Settings.readString("proxy").length>0 && System.Gadget.Settings.readString("proxy-username").length>0)
					doc.setProxyCredentials(System.Gadget.Settings.readString("proxy-username"),System.Gadget.Settings.readString("proxy-password"));
					doc.send(); 
				}
				catch (e)
				{
				}

				document.getElementById("url").value = targ.id;
				addUrl();
				refreshOtherFeedList();

			}
			catch (e)
			{
				//document.getElementById("errorbox").innerHTML = e.message;
			}
		}
		

		var right = document.createElement("div");
		right.className = "rightControls";
		right.appendChild(addbutton);

		item.appendChild(right);

		var text = document.createElement("div");
		text.innerHTML = feeds[i].getAttribute("name")+"&nbsp;";
		text.style.float = "left";
		text.style.margin = "0 0 5px 0";
		text.style.padding = "3px";
		text.style.borderBottom = "1px dashed #dedede";

		item.appendChild(text);

		var text2 = document.createElement("div");
		text2.innerHTML = feeds[i].text;
		text2.style.padding = "3px";
		text2.style.color = "#858585";

		item.appendChild(text2);

		

		list.appendChild(item);
	}


	for(var i=0;i<feedCategories.length;i++)
	{
		var option = document.createElement("option");
		option.innerHTML = feedCategories[i];
		option.title = feedCategories[i];
		document.getElementById("feedCategories").appendChild(option);
	}

	for(var i=0;i<feedLanguages.length;i++)
	{
		var option = document.createElement("option");
		option.innerHTML = feedLanguages[i];
		option.title = feedLanguages[i];
		document.getElementById("feedLanguages").appendChild(option);
	}
}



function relist()
{
	var items			= xmldoc.selectNodes("/data/feeds/feed");
	var list			= document.getElementById("feedlist");
	list.innerHTML		= "";

	for(var i=0;i<items.length;i++)
	{
		var item = document.createElement("div");
		
		item.className = "feeddiv";
		item.id = items[i].getAttribute("id");

		var deleteButton = document.createElement("a");
		deleteButton.innerHTML = "Remove";
		deleteButton.className = "delete";

		deleteButton.onclick = function(e)
		{
			try
			{
				var targ;
				if(!e) e = window.event;
				if (e.target) targ = e.target;
				else if (e.srcElement) targ = e.srcElement;

				while(targ.className.indexOf("feeddiv")<0) targ = targ.parentNode;

				targ.parentNode.removeChild(targ);

				var feeds	= xmldoc.selectNodes("/data/feeds/feed");

				for(var j=0;j<feeds.length;j++)
				{
					if(feeds[j].getAttribute("id") == targ.id)
					{
						xmldoc.selectSingleNode("/data/feeds").removeChild(feeds[j]);
						break;
					}
				}

			}
			catch (e)
			{
				document.getElementById("errorbox").innerHTML = e.message;
			}
		}

		var right = document.createElement("div");
		right.className = "rightControls";
		right.appendChild(deleteButton);

		item.appendChild(right);

		var text = document.createElement("div");
		text.innerHTML = items[i].getAttribute("name");
		text.style.float = "left";
		text.style.margin = "0 0 5px 0";
		text.style.padding = "3px";
		text.style.borderBottom = "1px dashed #dedede";

		item.appendChild(text);

		var interval				= document.createElement("input");
		interval.type				= "text";
		interval.className			= "interval";
		interval.id					= "interval"+items[i].getAttribute("id");
		interval.value				= (!items[i].getAttribute("interval"))?"20":items[i].getAttribute("interval");

		interval.onkeyup = function(e)
		{
			var targ;
			if(!e) e = window.event;
			if (e.target) targ = e.target;
			else if (e.srcElement) targ = e.srcElement;
			
			var items = xmldoc.selectNodes("/data/feeds/feed");

			for(var i=0;i<items.length;i++)
			{
				if("interval"+items[i].getAttribute("id") == targ.id) items[i].setAttribute("interval",targ.value);
			}

		}

		var t		= document.createElement("span");
		t.style.color = "#858585";
		t.innerHTML = "update interval ";

		var t2		= document.createElement("span");
		t2.style.color = "#858585";
		t2.innerHTML = " minutes";

		var left = document.createElement("div");
		left.style.float = "left";
		item.appendChild(left);
		left.appendChild(t);
		left.appendChild(interval);
		left.appendChild(t2);


		var dtitle = document.createElement("input");
		dtitle.type = "checkbox";
		dtitle.name = "display-title"+items[i].getAttribute("id");
		dtitle.id	= "display-title"+items[i].getAttribute("id");
		dtitle.title = "Check this to display the feed title over each newsitem in the scrolling list";
		dtitle.style.margin = "0";
		
		var dtitleLabel = document.createElement("span");
		dtitleLabel.innerHTML = "display title";
		dtitleLabel.title = "Check this to display the feed title over each newsitem in the scrolling list";

		left.appendChild(document.createElement("br"));
		left.appendChild(dtitle);
		left.appendChild(dtitleLabel);

		/*
		var bbcode = document.createElement("input");
		bbcode.type = "checkbox";
		bbcode.name = "bbcode"+items[i].getAttribute("id");
		bbcode.id	= "bbcode"+items[i].getAttribute("id");

		bbcode.style.margin = "0 0 0 20px";

		var bbcodeLabel = document.createElement("span");
		bbcodeLabel.innerHTML = "bbcode";

		left.appendChild(bbcode);
		left.appendChild(bbcodeLabel);
		*/

		list.appendChild(item);

		dtitle.checked = (items[i].getAttribute("display-title") == "true");

	}
}

function initialize(e)
{
	xmldoc.load(path);
	var items									= xmldoc.selectNodes("/data/feeds/feed");

	document.getElementById("scrollbox").value	= xmldoc.selectSingleNode("/data/tickspeed").text;

	document.getElementById("font-family").value	= xmldoc.selectSingleNode("/data/scroll-list").getAttribute("font");
	document.getElementById("font-size").value		= xmldoc.selectSingleNode("/data/scroll-list").getAttribute("font-size");
	document.getElementById("font-weight").value	= xmldoc.selectSingleNode("/data/scroll-list").getAttribute("weight");
	document.getElementById("font-color").value		= xmldoc.selectSingleNode("/data/scroll-list").getAttribute("color");


	document.getElementById("proxy").value			= xmldoc.selectSingleNode("/data/proxy").text;
	document.getElementById("proxy-username").value		= xmldoc.selectSingleNode("/data/proxy").getAttribute("username");
	document.getElementById("proxy-password").value	= xmldoc.selectSingleNode("/data/proxy").getAttribute("password");

	document.getElementById("newitemflagduration").value	= xmldoc.selectSingleNode("/data/new-item-flag").getAttribute("duration");

	document.getElementById("click-to-remove").checked	= ((xmldoc.selectSingleNode("/data/new-item-flag").getAttribute("click-to-remove") == "true")?true:false);


	document.getElementById("item-line-separator").checked	= ((xmldoc.selectSingleNode("/data/item-line-separator").getAttribute("enabled") == "true")?true:false);
	

	
	

	relist();

	var r = document.getElementsByTagName("input");
	for(var i=0;i<r.length;i++)
	{
		if(r[i].name == "displayType" && r[i].type == "radio")
		{
			if(r[i].value == System.Gadget.Settings.readString("displayType")) r[i].checked = true;
		}
	}
}

function testproxy()
{
	document.getElementById("proxytestwindow").innerHTML = "testing settings...";

	try
	{
		var doc    = new ActiveXObject( "MsXml2.ServerXmlHttp.6.0" );
		doc.setProxy(2,document.getElementById("proxy").value);
		doc.setTimeouts(50000, 50000, 50000, 50000);
		doc.onreadystatechange  = function()
		{
			//document.getElementById("proxytestwindow").innerHTML += doc.readyState+"<br/>";
			if (doc.readyState==4)
			{
				if(doc.status == 200)
				{
					if(doc.responseText.indexOf("<title>Microsoft Corporation</title>")>=0)
					{
						document.getElementById("proxytestwindow").innerHTML = "Settings seems to be okay";
					}
					else
					{
						document.getElementById("proxytestwindow").innerHTML = "Connection test did not return the expected contents";
					}
				}
				else
				{
					document.getElementById("proxytestwindow").innerHTML = "Settings are not okay!";
				}
				//document.getElementById("proxytestwindow").innerHTML += doc.status+"<br/>";
				//document.getElementById("proxytestwindow").innerHTML += doc.responseText+"<br/>";
			} 
		}
		doc.open("GET","http://www.microsoft.com",false);
		
		if(document.getElementById("proxy-username").value.length>0)
		{
			doc.setProxyCredentials(document.getElementById("proxy-username").value,document.getElementById("proxy-password").value);
		}
		
		doc.send(); 
	}
	catch (e)
	{
		document.getElementById("proxytestwindow").innerHTML = e.message;
	}
}

function addUrl()
{
	try
	{
		document.getElementById("errorbox").innerHTML = "";

		var tmpdoc				= new ActiveXObject( "Msxml2.DOMDocument.3.0" );
		var loader				= new ActiveXObject( "MsXml2.ServerXmlHttp.6.0" );
		tmpdoc.async			= false;
		
		tmpdoc.load(document.getElementById("url").value);

		if(System.Gadget.Settings.readString("proxy").length<=0)
		{
			tmpdoc.load(document.getElementById("url").value);
			append(tmpdoc);
		}
		else
		{
			loader.setProxy(2,System.Gadget.Settings.readString("proxy"));
			loader.onreadystatechange  = function()
			{
				if(loader.readyState != 4) return;
				if(loader.status != 200) return;
				tmpdoc.async	= false;
				if(!loader.responseXML)
				tmpdoc.loadXML(loader.responseText);
				else
				tmpdoc.loadXML(loader.responseXML.xml);
				append(tmpdoc);
			}
			loader.open("GET",document.getElementById("url").value,false);
			if(System.Gadget.Settings.readString("proxy").length>0 && System.Gadget.Settings.readString("proxy-username").length>0)
			loader.setProxyCredentials(System.Gadget.Settings.readString("proxy-username"),System.Gadget.Settings.readString("proxy-password"));
			loader.setRequestHeader("User-Agent","Hermes/1.0.4 (Windows; U; Windows NT 6.0; en-US; rv:1.8.1.11)");
			loader.setRequestHeader('Accept-Language', 'en-us;q=0.7,en;q=0.3');
			loader.setRequestHeader("Accept", "text/xml,application/xml,application/xhtml+xml,text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5");
			loader.setRequestHeader("Accept-Charset", "utf-8;q=0.7,*;q=0.7");
			loader.send();
			return;
		}

		



	}
	catch (e)
	{
		document.getElementById("errorbox").innerHTML = e.message+"The feed could not be read";
	}
}

function append(tmpdoc)
{
	try
	{
		var name = tmpdoc.selectSingleNode("//channel/title").text;

		var feed = xmldoc.createElement("feed");
		feed.setAttribute("name",name);
		feed.setAttribute("id",new Guid().toString());
		feed.setAttribute("interval","20");
		feed.text = document.getElementById("url").value;

		xmldoc.selectSingleNode("/data/feeds").appendChild(feed);

		var list = document.getElementById("feedlist");
		var item = document.createElement("div");
		item.className = "feeddiv";
		item.innerHTML = name;
		list.appendChild(item);

		document.getElementById("url").value = "";
		relist();
	}
	catch (e)
	{
		document.getElementById("errorbox").innerHTML = "append: The feed could not be read";
	}
}

function Guid()
{
	var _self = this;

	_self.value = "";


	var result, i, j;

	var result = '';

	for(j=0; j<32; j++)
	{
		if( j == 8 || j == 12|| j == 16|| j == 20)
		result = result + '-';

		i = Math.floor(Math.random()*16).toString(16).toUpperCase();

		result = result + i;
	}

	_self.value = result;

	this.toString = function()
	{
		return _self.value;
	}
}





function showTab(element,name,parent,container)
{

	var tabcontainer = "tabcontainer";
	if(container) tabcontainer = container;

	for(var i=0;i<document.getElementById(tabcontainer).childNodes.length;i++)
	{
		document.getElementById(tabcontainer).childNodes[i].className = "tab";
	}

	element.className = "tab selectedtab";

	var p = document;
	if(parent) p =  document.getElementById(parent);

	if(p.getElementById("general")) p.getElementById("general").style.display = "none";
	if(p.getElementById("fonts")) p.getElementById("fonts").style.display = "none";
	if(p.getElementById("background")) p.getElementById("background").style.display = "none";
	if(p.getElementById("connection")) p.getElementById("connection").style.display = "none";
	if(p.getElementById("feeds")) p.getElementById("feeds").style.display = "none";
	if(p.getElementById("otherfeeds")) p.getElementById("otherfeeds").style.display = "none";

	

	p.getElementById(name).style.display = "block";
	
}

function SettingsClosing(e)
{
		

	if (e.closeAction == e.Action.commit) 
	{
		try
		{
			xmldoc.selectSingleNode("/data/tickspeed").text = document.getElementById("scrollbox").value;

			xmldoc.selectSingleNode("/data/scroll-list").setAttribute("font",document.getElementById("font-family").value);
			xmldoc.selectSingleNode("/data/scroll-list").setAttribute("font-size",document.getElementById("font-size").value);
			xmldoc.selectSingleNode("/data/scroll-list").setAttribute("weight",document.getElementById("font-weight").value);
			xmldoc.selectSingleNode("/data/scroll-list").setAttribute("color",document.getElementById("font-color").value);

			xmldoc.selectSingleNode("/data/new-item-flag").setAttribute("duration",document.getElementById("newitemflagduration").value);

			xmldoc.selectSingleNode("/data/item-line-separator").setAttribute("enabled",((document.getElementById("item-line-separator").checked)?"true":"false"));
			

			xmldoc.selectSingleNode("/data/proxy").text = document.getElementById("proxy").value;

			xmldoc.selectSingleNode("/data/new-item-flag").setAttribute("click-to-remove",((document.getElementById("click-to-remove").checked)?"true":"false"));

			if(document.getElementById("proxy-save").checked)
			{
				xmldoc.selectSingleNode("/data/proxy").setAttribute("username",document.getElementById("proxy-username").value);
				xmldoc.selectSingleNode("/data/proxy").setAttribute("password",document.getElementById("proxy-password").value);
			} else
			{
				System.Gadget.Settings.writeString("proxy",document.getElementById("proxy").value);
				System.Gadget.Settings.writeString("proxy-username",document.getElementById("proxy-username").value);
				System.Gadget.Settings.writeString("proxy-password",document.getElementById("proxy-password").value);
				System.Gadget.Settings.writeString("proxy-nosave","true");
			}


			var items = xmldoc.selectNodes("/data/feeds/feed");

			for(var i=0;i<items.length;i++)
			{
				var t = document.getElementById("display-title"+items[i].getAttribute("id"));
				if(!t) continue;

				items[i].setAttribute("display-title",((t.checked)?"true":"false"));
			}

			xmldoc.save(path);

		}
		catch (e)
		{
			//System.Gadget.document.parentWindow.document.body.innerHTML = e.message;
			System.Gadget.Settings.writeString("error","closeerror::"+e.message);
		}
	}	
}

System.Gadget.onSettingsClosing = SettingsClosing;


