/*Default locale*/

function Locale()
{
	try
	{
		if(Locale.instance) throw("Locale instance exception");


		var _self = this;

		_self.localeDoc					= new ActiveXObject( "Msxml2.DOMDocument.6.0" );


		_self.getString = function(section,stringname)
		{
			return _self.localeDoc.selectSingleNode("sections/section[@name='"+section+"']/string[@name='"+stringname+"']").text;
		}

		_self.setInputValueString = function(inputid,section,stringname)
		{
			document.getElementById(inputid).value = _self.localeDoc.selectSingleNode("sections/section[@name='"+section+"']/string[@name='"+stringname+"']").text;
		}

		_self.setAltValueString = function(inputid,section,stringname)
		{
			document.getElementById(inputid).alt = _self.localeDoc.selectSingleNode("sections/section[@name='"+section+"']/string[@name='"+stringname+"']").text;
			document.getElementById(inputid).title = _self.localeDoc.selectSingleNode("sections/section[@name='"+section+"']/string[@name='"+stringname+"']").text;
		}

		function initialize()
		{
			_self.localeDoc.async		= false;
			_self.localeDoc.load("locale.xml");
		}

		initialize();
	}
	catch (e)
	{
		document.write(e.message);
	}
}

Locale.instance = new Locale();