	function search()
	{
		try
		{
			var feeds = System.Gadget.document.parentWindow.Feeds.instance.feeds;

			var matches = new Array();

			var keyWords = document.getElementById("keywords").value.split(",");

			for(var k=0;k<keyWords.length;k++)
			{
				var key = keyWords[k].toLowerCase();

				for(var i=0;i<feeds.length;i++)
				{
					for(var j=0;j<feeds[i].items.length;j++)
					{
						var found = false;
						if(feeds[i].items[j].toLowerCase().indexOf(key)>=0)
						{
							found = true;
						}
						if(feeds[i].news[j+"_"+feeds[i].items[j].replace(/[^a-z]/ig,"-")].selectSingleNode("description").text.toLowerCase().indexOf(key)>=0)
						{
							found = true;
						}

						if(found) matches.push({feed:i,item:feeds[i].news[j+"_"+feeds[i].items[j].replace(/[^a-z]/ig,"-")]});
					}
				}
			}


			//document.getElementById("results").removeAllChildren();
			document.getElementById("results").innerHTML = "<div style='margin:5px;'>"+matches.length+" matches</div>";
			
			for(var i=0;i<matches.length;i++)
			{
				var div = document.createElement("div");

				div.id = "";
				div.innerHTML = "<div style='float:right;'><a href='"+matches[i].item.selectSingleNode("link").text+"'>link</a></div>";
				div.innerHTML += "<div class='feedname'>"+feeds[matches[i].feed].name+"</div>"+matches[i].item.selectSingleNode("title").text;
				div.className = "match";

				var details = document.createElement("div");
				details.className = "details";
				details.id = matches[i].item.selectSingleNode("description").text;
				details.innerHTML = "more...";

				details.onclick = function(e)
				{
					var targ;
					if(!e) e = window.event;
					if (e.target) targ = e.target;
					else if (e.srcElement) targ = e.srcElement;
					while(targ.className.indexOf("details")<0) targ = targ.parentNode;

					if(targ.innerHTML == "more...") 
						targ.innerHTML = targ.id;
					else
						targ.innerHTML = "more...";
				}

				div.appendChild(details);

				div.onmouseover = function(e)
				{
					var targ;
					if(!e) e = window.event;
					if (e.target) targ = e.target;
					else if (e.srcElement) targ = e.srcElement;
					while(targ.className.indexOf("match")<0) targ = targ.parentNode;

					targ.style.backgroundColor = "#000000";
					targ.style.color = "#ffffff";
				}

				div.onmouseout = function(e)
				{
					var targ;
					if(!e) e = window.event;
					if (e.target) targ = e.target;
					else if (e.srcElement) targ = e.srcElement;
					while(targ.className.indexOf("match")<0) targ = targ.parentNode;

					targ.style.backgroundColor = "#ffffff";
					targ.style.color = "#000000";
				}

				document.getElementById("results").appendChild(div);
			}
		}
		catch (e)
		{
			document.getElementById("results").innerHTML = e.message;
		}
	}


	function save()
	{
		System.Gadget.document.parentWindow.Feeds.instance.keyWords = document.getElementById("keywords").value.split(",");
		System.Gadget.Flyout.show = false;
	}

	function initialize()
	{
		for(var i=0;i<System.Gadget.document.parentWindow.Feeds.instance.keyWords.length;i++)
		{
			document.getElementById("keywords").value += System.Gadget.document.parentWindow.Feeds.instance.keyWords[i];
			if(i!=System.Gadget.document.parentWindow.Feeds.instance.keyWords.length-1)
			document.getElementById("keywords").value += ",";
		}
	}